unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, VBXCtrl, Switch;

type
  TForm1 = class(TForm)
    Button1: TButton;
    BiSwitch1: TBiSwitch;
    BiSwitch2: TBiSwitch;
    BiSwitch3: TBiSwitch;
    BiSwitch4: TBiSwitch;
    BiSwitch5: TBiSwitch;
    BiSwitch6: TBiSwitch;
    BiSwitch7: TBiSwitch;
    BiSwitch8: TBiSwitch;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure BiSwitch1On(Sender: TObject);
    procedure BiSwitch1Off(Sender: TObject);
    procedure BiSwitch2On(Sender: TObject);
    procedure BiSwitch2Off(Sender: TObject);
    procedure BiSwitch3On(Sender: TObject);
    procedure BiSwitch3Off(Sender: TObject);
    procedure BiSwitch4On(Sender: TObject);
    procedure BiSwitch4Off(Sender: TObject);
    procedure BiSwitch5On(Sender: TObject);
    procedure BiSwitch5Off(Sender: TObject);
    procedure BiSwitch6On(Sender: TObject);
    procedure BiSwitch6Off(Sender: TObject);
    procedure BiSwitch7On(Sender: TObject);
    procedure BiSwitch7Off(Sender: TObject);
    procedure BiSwitch8On(Sender: TObject);
    procedure BiSwitch8Off(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure BiSwitch8MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BiSwitch7MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BiSwitch6MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BiSwitch5MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BiSwitch4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BiSwitch3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BiSwitch2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BiSwitch1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
    { Speichert die Zustnde der Relais }
    Relaiszustand: Byte;
  public
    { Public-Deklarationen }
  end;

const
  { IO-Adresse der RL 1335 }
  KartenAdresse = $100;
var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.BiSwitch1On(Sender: TObject);
begin
  {  Relais 1 auf AN }
  Relaiszustand := Relaiszustand or 1;
end;

procedure TForm1.BiSwitch1Off(Sender: TObject);
begin
  { Relais 1 auf AUS }
  Relaiszustand := Relaiszustand and $FE;
end;

procedure TForm1.BiSwitch1MouseDown(Sender: TObject; Button: TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
begin
  { Relaiszustand auf IO-Adresse ausgeben }
  Port[KartenAdresse] := Relaiszustand;
end;

procedure TForm1.BiSwitch2On(Sender: TObject);
begin
  { Relais 2 auf AN }
  Relaiszustand := Relaiszustand or 2;
end;

procedure TForm1.BiSwitch2Off(Sender: TObject);
begin
  { Relais 2 auf AUS }
  Relaiszustand := Relaiszustand and $FD;
end;

procedure TForm1.BiSwitch2MouseDown(Sender: TObject; Button: TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
begin
  { Relaiszustand auf IO-Adresse ausgeben }
  Port[KartenAdresse] := Relaiszustand;
end;

procedure TForm1.BiSwitch3On(Sender: TObject);
begin
  { Relais 3 auf AN }
  Relaiszustand := Relaiszustand or 4;
end;

procedure TForm1.BiSwitch3Off(Sender: TObject);
begin
  { Relais 3 auf AUS }
  Relaiszustand := Relaiszustand and $FB;
end;

procedure TForm1.BiSwitch3MouseDown(Sender: TObject; Button: TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
begin
  { Relaiszustand auf IO-Adresse ausgeben }
  Port[KartenAdresse] := Relaiszustand;
end;

procedure TForm1.BiSwitch4On(Sender: TObject);
begin
  { Relais 4 auf AN }
  Relaiszustand := Relaiszustand or 8;
end;

procedure TForm1.BiSwitch4Off(Sender: TObject);
begin
  { Relais 4 aus AUS }
  Relaiszustand := Relaiszustand and $F7;
end;

procedure TForm1.BiSwitch4MouseDown(Sender: TObject; Button: TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
begin
  { Relaiszustand auf IO-Adresse ausgeben }
  Port[KartenAdresse] := Relaiszustand;
end;

procedure TForm1.BiSwitch5On(Sender: TObject);
begin
  { Relais 5 auf AN }
  Relaiszustand := Relaiszustand or 16;
end;

procedure TForm1.BiSwitch5Off(Sender: TObject);
begin
  { Relais 5 auf AUS }
  Relaiszustand := Relaiszustand and $EF;
end;

procedure TForm1.BiSwitch5MouseDown(Sender: TObject; Button: TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
begin
  { Relaiszustand auf IO-Adresse ausgeben }
  Port[KartenAdresse] := Relaiszustand;
end;

procedure TForm1.BiSwitch6On(Sender: TObject);
begin
  { Relais 6 auf AN }
  Relaiszustand := Relaiszustand or 32;
end;

procedure TForm1.BiSwitch6Off(Sender: TObject);
begin
  { Relais 6 auf AUS }
  Relaiszustand := Relaiszustand and $DF;
end;

procedure TForm1.BiSwitch6MouseDown(Sender: TObject; Button: TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
begin
  { Relaiszustand auf IO-Adresse ausgeben }
  Port[KartenAdresse] := Relaiszustand;
end;

procedure TForm1.BiSwitch7On(Sender: TObject);
begin
  { Relais 7 auf AN }
  Relaiszustand := Relaiszustand or 64;
end;

procedure TForm1.BiSwitch7Off(Sender: TObject);
begin
  { Relais 7 auf AUS }
  Relaiszustand := Relaiszustand and $BF;
end;

procedure TForm1.BiSwitch7MouseDown(Sender: TObject; Button: TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
begin
  { Relaiszustand auf IO-Adresse ausgeben }
  Port[KartenAdresse] := Relaiszustand;
end;

procedure TForm1.BiSwitch8On(Sender: TObject);
begin
  { Relais 8 auf AN }
  Relaiszustand := Relaiszustand or 128;
end;

procedure TForm1.BiSwitch8Off(Sender: TObject);
begin
  { Relais 8 auf AUS }
  Relaiszustand := Relaiszustand and $7F;
end;

procedure TForm1.BiSwitch8MouseDown(Sender: TObject; Button: TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
begin
  { Relaiszustand auf IO-Adresse ausgeben }
  Port[KartenAdresse] := Relaiszustand;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  { Relais zurcksetzen }
  Port[KartenAdresse] := 0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  { Relais in Ausgangszustand versetzen }
  Relaiszustand := 0;
  Port[KartenAdresse] := Relaiszustand;
end;

end.
